"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Class AppletRepresentationChainModifier
 */
class AppletRepresentationChainModifier {
    constructor(representation) {
        this.representation = representation;
    }
    /**
     * Modify applet's name
     * @param appletName
     * @return {AppletRepresentationChainModifier}
     */
    name(appletName) {
        this.representation.appletName = appletName;
        return this;
    }
    /**
     * Modify applet's category
     * @param processName
     * @return {AppletRepresentationChainModifier}
     */
    process(processName) {
        this.representation.category = processName;
        return this;
    }
    /**
     * Modify applet's config
     * @param configResolver
     * @return {AppletRepresentationChainModifier}
     */
    config(configResolver) {
        if ('function' === typeof configResolver) {
            this.representation.configResolver = configResolver;
            return this;
        }
        this.representation.config = configResolver;
        return this;
    }
}
exports.AppletRepresentationChainModifier = AppletRepresentationChainModifier;
//# sourceMappingURL=AppletRepresentationChainModifier.js.map